package de.his.UNOPdfExport;

import java.io.File;

import com.sun.star.text.XTextDocument;

import de.his.core.util.openoffice.OOoConnection;
import de.his.core.util.openoffice.OOoHelper;

public class PdfExport {

	private String TEST_FILE_URL = "test.odt";

	private int REPEAT_COUNT = 2000;

	public static void main(String[] args) throws Exception {

		PdfExport pdfExport = new PdfExport();
		pdfExport.doWork();
		
		System.out.println("The End...");
		System.exit(0);
	}

	private void doWork() throws Exception {

		OOoConnection conn = null;
		OOoHelper oh = new OOoHelper();

		try {
			conn = oh.getConnection();
		} catch (Exception e) {

			// ooooh... fail...
			System.out.println(e.getMessage());
			System.exit(1);
		}

		String url = getPathToFile() + TEST_FILE_URL;
		System.out.println(url);
		XTextDocument template = OOoHelper.loadTextDocument(
				conn.getComponentLoader(), OOoHelper.PROTOCOL_FILE, url,
				true);
		
		for (int i = 1; i <= REPEAT_COUNT; i++) {

			new OOoHelper().storeAsTemp(template, "_" + i + "_",
					"pdf", Long.valueOf(0));
			try{
//				System.out.println("Stored file under: "+tempFilePdf.getCanonicalPath());
			}catch(Exception e){
				// nothing
				System.exit(1);
			}
			
		}
		oh.close();
		

	}

	private String getPathToFile() {
		File file = new File(".");
		String path = "";
		try {
			path = file.getCanonicalPath();
		} catch (Exception e) {
			// nothing
			System.exit(1);
		}

		System.out.println(path);
		return path+"/";
	}
	
	

}
