/*
 * Copyright (c)2008 Hochschul-Informations-System GmbH
 *
 * $Id: OOoConnection.java,v 1.2 2012-12-20 10:33:26 wahrendorff#his.de Exp $
 *
 * $Log: OOoConnection.java,v $
 * Revision 1.2  2012-12-20 10:33:26  wahrendorff#his.de
 * PDF/A1-a zu PDF 1.4 umgestellt #82643, Warnings und unnötige casts beseitigt.
 *
 * Revision 1.1  2012-12-04 09:37:25  wahrendorff#his.de
 * OOoHelper & OOoConnection Klassen in core verschoben, Template Service Funktionen in OOoReportService ausgelagert, betroffene Spring Bean Konfigurationen angepasst, getestet.
 *
 * Revision 1.1  2012-12-03 14:03:57  wahrendorff#his.de
 * Architekturverstöße aufgelöst #64641
 *
 * Revision 1.2  2010-09-30 16:50:34  lustig#his.de
 * OOConnect -> OOConnection
 *
 * Revision 1.1  2010-09-29 11:51:16  lustig#his.de
 * Test zu Mehrbenutzerbetrieb des OOReporting
 *
 * Revision 1.7  2010-08-02 08:28:40  wahrendorff#his.de
 * trennung von output und layout komplett. unbenutzte Methoden entfernt. unerreichbaren Code entfernt
 *
 * Revision 1.6  2010-07-23 15:21:50  wahrendorff#his.de
 * behandlung der disposed Exception nochmals verbesserst.
 *
 * Revision 1.5  2010-07-16 14:01:32  wahrendorff#his.de
 * Verbindung zu OpenOffice neu herstellen, wenn die Verbindung eine DisposedException schmeisst
 *
 * Revision 1.4  2010-06-07 14:29:55  wahrendorff#his.de
 * ausgabe eines Dokumentes in beliebigem Format
 *
 * Revision 1.3  2010-06-01 13:09:16  wahrendorff#his.de
 * aufgeräumt, kleine bugs gefixt
 *
 * Revision 1.2  2010-05-27 15:04:45  wahrendorff#his.de
 * Ausgabe von PDF Dokumentenaus odt Vorlagen realisiert
 *
 * Revision 1.1  2010-05-20 15:35:45  wahrendorff#his.de
 * Dateien sinnvoll umbenannt, reportController noch unfertig
 *
 * Revision 1.9  2010-03-26 08:22:08  wahrendorff#his.de
 * weniger Warnings, Codepflege
 *
 * Revision 1.8  2010-03-09 16:15:38  wahrendorff#his.de
 * Aufruf und Rückgabe eines XTextDocuments Interface, auslesen des Texts, ausgeben des Textes, schreiben des Text in ein neues, leeres, XTextDocument erfolgreich.
 *
 * Revision 1.7  2010-03-08 14:48:08  wahrendorff#his.de
 * more logging for InstallationFinder to find issues with finding the installation.
 * OoHelperTest gets an object from OO wich holds a representation of an OO-Writer-Document you can actually work with.
 * more logging for connect-class, to see what it does.
 * connect gets called only one time, instead of two times in some cases. (better checks)
 *
 * Revision 1.6  2010-02-04 17:01:50  wahrendorff#his.de
 * es kann ein leeres writer Dokument im Speicher erzeugt oder ein Writer Dokument von einer Datei in den Speicher gelesen werden
 *
 * Revision 1.5  2010-01-26 16:57:31  jauer#his.de
 * Compiler Errors formally fixed
 *
 * Revision 1.4  2010-01-26 16:11:07  wahrendorff#his.de
 * es wurde bis zur erzeugten OpenOffice Instanz vorgerrückt. Der Helper ist noch leer
 *
 * Revision 1.3  2010-01-25 15:44:47  wahrendorff#his.de
 * OO Reporting... Skelettaufbau
 *
 *
 *
 */


/*
 * any questions? mail tim[at]timwahrendorff.de
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNOOO8MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM8O$ZD8DDNMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM8OZ$OZZ??ZZOZZ88ONMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM$II??$N$?+$ZZ8ZI?I$DMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNZ$7?+IMN8$ZDMN++++IDNMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMDIZZZZ$ZMMMOZNM$++++?+IMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM87+?I8ZZZZZDMMMMMOZ?++++++DMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMD$?+IO8Z$ZZZZZMMMMMMM8$I??7IZMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM$DDMMMM$??78DNMMMMMMMMMNNMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMNDMMMMMM$+++?NMMMMMMMMMMMMOZMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMDOMM$Z8DI+++++++++78DD8Z$?+++++ZM8OMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMOIII?$O$+++++++++++++++++++++++?MMNMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMN8I+$D8MMO++++++++++++++++++++++++NMM8MMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMZIIZZDMM??+++++++I?+++++++++++++++DM8NMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMNI+?ZZMN$++++++++++++++++++++++++++8MNDMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMD?+I$$MO?++++++++++++++++++++++++++8MMDMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMN$7MNNM8++++++++?I??+++++++++++++++8MM8NMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMZNMMMN?++++?ZNMMMMDZ?+++++NMMMMM8+IMMNMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMDMMMM7++++?$OMMMMNZZI+++IDMMMMMMD?IMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMDDMMM?++?DMMMMMMMMMD$++DMMMMMMMMM$$MMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMI++IMMMD$IDMMMM$+?MMMN77MMMMZ7MMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMNMMM?+++III++++$O$+++++?Z$?+??I7++$MMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMDOOZNM?+++++++++7ZZ?+++++?$$Z$7?++++IMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMN$ZZ++++++++$N8?+++++++??++???++++OMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMNNMZ++++++++??++++++++++++++++++++IMNMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMN8I$$?++++++++++++++7ZZO8DO+++++++++?DDMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMDO7??+I++++++++++++7MMMMMMMZ++++++???NDMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMNDD$O8M7+++++++++++?NO$O8DM7+++++?+??MNMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN87+++++++++++?ZI++=7M8I++++????MNMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMNNNNM7++++++++78888DO7IIOMMDI++??ZDMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMDO8O?+++++++7MMMMMMMMMMMMMM8++??8NMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMMMMNMMMO++++++?8ND8Z$$$$$$$O8N$++++?ZMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMMN8$MMMMN?++++++++++++?ZZI+++++++?7ZI?MMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMM8Z7ZMMMMMZ++++++++++++IZZZ?+++++IZOZI+MMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMM$?OMMMMMMN$MDZ+++++++++?7$?++++?OMMZZZO8DMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMM7?MMMMMMMNINMN$7I?+++++++++++++ZMMMOMMOZOOMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMMI++78OOMMM?+INMNMDZ7??????I7$ONMMMO$ZZZZZZDMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMM?++++?IMMM?++?MMMMMDZZZZZZZZDMMMNZZZZZZZOD88NMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMN???++++8MM7+++$DMMMMMNDDMMMMMMMOZZZZZZOMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMMMDZMM$++++ON$+++++IDMMMMMMMMMMMN8ZZZZZZ8MMMMMMMMMMMMMMMMMM
MMMMMMMMMMMMMMMMMMMMMM8ZMMMDZ$7++++++++++?8NMMMMMN8OZZZZZ$ZMMMMMMOMMMMMMDOMMMMMM
MMMMMMMMMMMMMMMMMMMMN8OOMMMNMNDZ7?+++++++?$ZZZZZZZZZZZZZODMMMMMMN8MMMMMDZNMMMMMM
MMMMMMMMMMMMMMMMMMMN$I$$MMMMMMMMMMMDO7I?I$ZZZZZZZZZZZ$OMMMMMMMMMMMMMMDZZZODMMMMM
MMMMMMMMMMMMMMMMMM8I+++$MMMMMMZOMMMMMNOZZZZZZZZZZZZZZDMMMMMMMMMMMMDNNZZZ$$ZOMMMM
MMMMMMMMMMMMMMMMM7+?I?7ZNMMMMMO++7DMMMDZ$ZDMMMDZZZONMMMMMMMMMMMMMN8DOZ8MMMD8Z8DM
MMMMMMMMMMMMMMMO7+?ZZ$OM$DMMMMN+++?ZZO$ZZMMMMNZZZNMMMMMMMMMMMMMMMOONMMMMMMMMMMMM
MMMMMMMMMMMMMDI++8ZZZ8MMDZNMMMMI?+7O8DMMMMN8ZZ8NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
MMMMMMMMMMMM88++7M8$OMMMMMMMMMM8ZDMMMMMMNO$ZZMMMMMMNNNMMMNNMMMMMMMMMMMMMMZZOMMMM
MMMMMMMMMMDMM87$MMDMN8MMMMMMMMDMD8DD8OZ$Z8NMMMMNDZ$ZZZ$ZZO8MMMMMMMMM8MMMMZZZ7?$N
MMMMMMMMMNMMD$ZZDMMMZZNMMMMMMMOMD$ZZZ$Z8MMMMMM8$$$$$ZOOMMMMMMMMMMM8Z$MMMMZZZZ77Z
 * 
 */

package de.his.core.util.openoffice;

import java.net.ConnectException;


import com.sun.star.beans.XPropertySet;
import com.sun.star.bridge.XBridge;
import com.sun.star.bridge.XBridgeFactory;
import com.sun.star.comp.helper.Bootstrap;
import com.sun.star.connection.NoConnectException;
import com.sun.star.connection.XConnection;
import com.sun.star.connection.XConnector;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.frame.XDesktop;
import com.sun.star.lang.EventObject;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XEventListener;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

/**
 * Diese Klasse stellt die Verbindung zum OpenOffice Server dar.
 * Connections werden angefordert vom 'OOoConnectionPool', der als Bean 'oOoConnectionPool' im ApplicationContext liegt.
 * Wird von OOoHelper instanziert und genutzt.
 * 
 * @author wahrendorff#his.de, lustig#his.de
 * @version $Id: OOoConnection.java,v 1.2 2012-12-20 10:33:26 wahrendorff#his.de Exp $ 
 */
public class OOoConnection implements XEventListener  {
    //private static Logger logger = //logger.getLogger(OOoConnection.class);    

    /*
     * Connection Ressources
     */
    private XBridge bridge;    
    private XComponent bridgeComponent;
    private XMultiComponentFactory serviceManager;
    private XComponentContext componentContext;

    /*
     * Connection Properties
     */
    private String connectionString;    
    private boolean connected = false;
    private boolean expectingDisconnection = false;
    
    
    
    /**
     * No-arg Constructor
     */
    public OOoConnection() {
        super();
    }
    
    /**
     * 
     * @param connectionString
     * @throws ConnectException
     */
    synchronized void connect(String aConnectionString) throws ConnectException {
        connectionString = aConnectionString;                
        //logger.debug("connecting to OpenOffice-Server via: " + connectionString);
        
        try {
            // TODO: Stelle finden, wo auf den Server-Start gewartet werden kann / muss
            
            XComponentContext localContext = Bootstrap.createInitialComponentContext(null);                                    
            XMultiComponentFactory localSvcManager = localContext.getServiceManager();
            XBridgeFactory bridgeFactory = UnoRuntime.queryInterface(XBridgeFactory.class, localSvcManager.createInstanceWithContext("com.sun.star.bridge.BridgeFactory", localContext));
                                    
            XConnector connector = UnoRuntime.queryInterface(XConnector.class, localSvcManager.createInstanceWithContext("com.sun.star.connection.Connector", localContext));
            XConnection masterConnection = connector.connect(connectionString);
            
            // TODO: Hier einen Bridge-Namen angeben?
            bridge = bridgeFactory.createBridge("", "urp", masterConnection, null);
            bridgeComponent = UnoRuntime.queryInterface(XComponent.class, bridge);
            bridgeComponent.addEventListener(this);
            serviceManager = UnoRuntime.queryInterface(XMultiComponentFactory.class, bridge.getInstance("StarOffice.ServiceManager"));
            XPropertySet properties = UnoRuntime.queryInterface(XPropertySet.class, serviceManager);
            componentContext = UnoRuntime.queryInterface(XComponentContext.class, properties.getPropertyValue("DefaultContext"));
            
            connected = true;         
            //logger.info("connected to OpenOffice-Server");
        }
        catch (NoConnectException connectException) {
            throw new ConnectException("connection failed: "+ connectionString +": " + connectException.getMessage());
        } catch (Exception exception) {
            throw new OpenOfficeException("connection failed: "+ connectionString, exception);
        }        
    }
    
    
    /**
     * Reconnect with same ConnectionString after Bridge disposal
     * @throws ConnectException
     */
    private synchronized void reconnect() throws ConnectException {
        if (connectionString == null) {
            throw new IllegalStateException("Must connect before reconnect!");            
        }
        
        connect(connectionString);        
    }
    
    
    /**
     * Test if there is a Connection and reconnect if not so 
     */
    private void ensureConnection() {
        try {
            if (!connected) {
                //logger.info("trying to (re)connect to OpenOffice");
                reconnect();
            }
        }
        catch (Exception exception) {
            throw new OpenOfficeException("Could not (re)connect to OpenOffice!", exception);
        }
    }    
    

    /**
     * Disconnect by disposing of the bridge
     */
    public synchronized void disconnect() {
        //logger.debug("disconnecting");
        expectingDisconnection = true;
        bridgeComponent.dispose();
    }

    
    /**
     * @return true, if bridge is connected and undisposed
     */
    public boolean isConnected() {
        return connected;
    }

    
    /**
     * Called via XEventListener-Interface, if bridge is disposed
     */
    @Override
    public void disposing(EventObject event) {
        connected = false;
        if (expectingDisconnection) {
            //logger.info("disconnected");
        } else {
            //logger.error("disconnected unexpectedly");
        }
        expectingDisconnection = false;
    }

    
    /*
     * Basic Component Access
     */
    
    /**
     * @return remoteServiceManager
     */
    public XMultiComponentFactory getServiceManager() {
        ensureConnection();        
        return serviceManager;
    }

    
    /**
     * @return ComponentContext
     */
    public XComponentContext getComponentContext() {
        ensureConnection();        
        return componentContext;
    } 
    
    
    /**
     * @param contextName
     * @return ServiceComponent with given Context (still castable to all available Interfaces)
     */
    public Object getComponent(String contextName) {
        try {
            return getServiceManager().createInstanceWithContext(contextName, getComponentContext());
        }
        catch (Exception exception) {
            throw new OpenOfficeException("could not obtain service component: " + contextName, exception);
        }
    }    
    
    
    /**
     * @param <T> 
     * @param contextName
     * @param interfaceClass 
     * @return ServiceComponent with given Context castet to given Interface
     */
    public <T> T getComponent(String contextName, Class<T> interfaceClass) {
        return UnoRuntime.queryInterface(interfaceClass, getComponent(contextName));
    }

    
    /*
     * Convenience - Access
     */
    
    /**
     * @return "com.sun.star.frame.Desktop" - XComponentLoader
     */
    public XComponentLoader getComponentLoader() {
        return getComponent("com.sun.star.frame.Desktop", XComponentLoader.class);
    }
    
    /**
     * @return "com.sun.star.frame.Desktop" - XDesktop
     */
    public XDesktop getDesktop() {
        return getComponent("com.sun.star.frame.Desktop", XDesktop.class);
    }    

    
}
